/*****************************************************************************/
/* Copyright (C) 1995 Novell, Inc. and AT&T Bell Labs.  All rights reserved. */
/*****************************************************************************/
/* abstract syntax: att_asn_tbl */
/* last module in input: ATT-private-identifiers */
/* created: Wed Feb 15 17:46:02 1995 */
/* associated control file: attpdefs.c */

#ifndef ATTPDEFS_H
#define ATTPDEFS_H

#include "cstadefs.h"


#define          ATT_CLEAR_CONNECTION 1
#define          ATT_CONSULTATION_CALL 2
#define          ATT_MAKE_CALL 3
#define          ATT_DIRECT_AGENT_CALL 4
#define          ATT_MAKE_PREDICTIVE_CALL 5
#define          ATT_SUPERVISOR_ASSIST_CALL 6
#define          ATT_RECONNECT_CALL 7
#define          ATT_SENDDTMF_TONE 8
#define          ATT_SENDDTMF_TONE_CONF 9
#define          ATT_SET_AGENT_STATE 10
#define          ATT_QUERY_ACD_SPLIT 11
#define          ATT_QUERY_ACD_SPLIT_CONF 12
#define          ATT_QUERY_AGENT_LOGIN 13
#define          ATT_QUERY_AGENT_LOGIN_CONF 14
#define          ATT_QUERY_AGENT_LOGIN_RESP 15
#define          ATT_QUERY_AGENT_STATE 16
#define          ATT_QUERY_AGENT_STATE_CONF 17
#define          ATT_QUERY_CALL_CLASSIFIER 18
#define          ATT_QUERY_CALL_CLASSIFIER_CONF 19
#define          ATT_QUERY_DEVICE_INFO_CONF 20
#define          ATT_QUERY_MWI_CONF 21
#define          ATT_QUERY_STATION_STATUS 22
#define          ATT_QUERY_STATION_STATUS_CONF 23
#define          ATT_QUERY_TOD 24
#define          ATT_QUERY_TOD_CONF 25
#define          ATT_QUERY_TG 26
#define          ATT_QUERY_TG_CONF 27
#define          ATT_SNAPSHOT_DEVICE_CONF 28
#define          ATT_MONITOR_FILTER 29
#define          ATT_MONITOR_CONF 30
#define          ATT_MONITOR_STOP_ON_CALL 31
#define          ATT_MONITOR_STOP_ON_CALL_CONF 32
#define          ATT_MONITOR_CALL_CONF 33
#define          ATT_CALL_CLEARED 34
#define          ATT_CONFERENCED 35
#define          ATT_CONNECTION_CLEARED 36
#define          ATT_DELIVERED 37
#define          ATT_ENTERED_DIGITS 38
#define          ATT_ESTABLISHED 39
#define          ATT_NETWORK_REACHED 40
#define          ATT_TRANSFERRED 41
#define          ATT_ROUTE_REQUEST 42
#define          ATT_ROUTE_SELECT 43
#define          ATT_ROUTE_USED 44
#define          ATT_SYS_STAT 45
#define          ATT_LINK_STATUS 46

typedef enum ATTUUIProtocolType_t {
    UUI_NONE = -1,
    UUI_USER_SPECIFIC = 0,
    UUI_IA5_ASCII = 4
} ATTUUIProtocolType_t;

typedef struct ATTUserToUserInfo_t {
    ATTUUIProtocolType_t type;
    struct {
        short           length;
        unsigned char   value[33];
    } data;
} ATTUserToUserInfo_t;

typedef enum ATTInterflow_t {
    LAI_NO_INTERFLOW = -1,
    LAI_ALL_INTERFLOW = 0,
    LAI_THRESHOLD_INTERFLOW = 1,
    LAI_VECTORING_INTERFLOW = 2
} ATTInterflow_t;

typedef enum ATTPriority_t {
    LAI_NOT_IN_QUEUE = 0,
    LAI_LOW = 1,
    LAI_MEDIUM = 2,
    LAI_HIGH = 3,
    LAI_TOP = 4
} ATTPriority_t;

typedef struct ATTLookaheadInfo_t {
    ATTInterflow_t  type;
    ATTPriority_t   priority;
    short           hours;
    short           minutes;
    short           seconds;
    DeviceID_t      sourceVDN;
} ATTLookaheadInfo_t;

typedef enum ATTUserEnteredCodeType_t {
    UE_NONE = -1,
    UE_ANY = 0,
    UE_LOGIN_DIGITS = 2,
    UE_CALL_PROMPTER = 5,
    UE_DATA_BASE_PROVIDED = 17,
    UE_TONE_DETECTOR = 32
} ATTUserEnteredCodeType_t;

typedef enum ATTUserEnteredCodeIndicator_t {
    UE_COLLECT = 0,
    UE_ENTERED = 1
} ATTUserEnteredCodeIndicator_t;

typedef struct ATTUserEnteredCode_t {
    ATTUserEnteredCodeType_t type;
    ATTUserEnteredCodeIndicator_t indicator;
    char            data[25];
    DeviceID_t      collectVDN;
} ATTUserEnteredCode_t;

typedef struct ATTConnIDList_t {
    short           count;
    ConnectionID_t  party[5];
} ATTConnIDList_t;

typedef enum ATTProgressLocation_t {
    PL_USER = 0,
    PL_PUB_LOCAL = 1,
    PL_PUB_REMOTE = 4,
    PL_PRIV_REMOTE = 5
} ATTProgressLocation_t;

typedef enum ATTProgressDescription_t {
    PD_CALL_OFF_ISDN = 1,
    PD_DEST_NOT_ISDN = 2,
    PD_ORIG_NOT_ISDN = 3,
    PD_CALL_ON_ISDN = 4,
    PD_INBAND = 8
} ATTProgressDescription_t;

typedef enum ATTWorkMode_t {
    WM_AUX_WORK = 1,
    WM_AFTCAL_WK = 2,
    WM_AUTO_IN = 3,
    WM_MANUAL_IN = 4
} ATTWorkMode_t;

typedef enum ATTTalkState_t {
    TS_ON_CALL = 0,
    TS_IDLE = 1
} ATTTalkState_t;

typedef enum ATTExtensionClass_t {
    EC_VDN = 0,
    EC_ACD_SPLIT = 1,
    EC_ANNOUNCEMENT = 2,
    EC_DATA = 4,
    EC_ANALOG = 5,
    EC_PROPRIETARY = 6,
    EC_BRI = 7,
    EC_CTI = 8,
    EC_LOGICAL_AGENT = 9,
    EC_OTHER = 10
} ATTExtensionClass_t;

typedef enum ATTAnswerTreat_t {
    AT_NONE = 1,
    AT_DROP = 2,
    AT_CONNECT = 3
} ATTAnswerTreat_t;

typedef unsigned char   ATTMwiApplication_t;
#define                     AT_MCS 0x01
#define                     AT_VOICE 0x02
#define                     AT_PROPMGT 0x04
#define                     AT_LWC 0x08
#define                     AT_CTI 0x10

typedef unsigned char   ATTPrivateFilter_t;
#define                     ATT_ENTERED_DIGITS_FILTER 0x80

typedef struct ATTSnapshotCall_t {
    short           count;
    CSTASnapshotCallResponseInfo_t info[6];
} ATTSnapshotCall_t;

typedef enum ATTLocalCallState_t {
    ATT_CS_INITIATED = 1,
    ATT_CS_ALERTING = 2,
    ATT_CS_CONNECTED = 3,
    ATT_CS_HELD = 4,
    ATT_CS_BRIDGED = 5,
    ATT_CS_OTHER = 6
} ATTLocalCallState_t;

typedef struct ATTSnapshotDevice_t {
    ConnectionID_t  call;
    ATTLocalCallState_t state;
} ATTSnapshotDevice_t;

typedef enum ATTCollectCodeType_t {
    UC_NONE = 0,
    UC_TONE_DETECTOR = 32
} ATTCollectCodeType_t;

typedef enum ATTProvidedCodeType_t {
    UP_NONE = 0,
    UP_DATA_BASE_PROVIDED = 17
} ATTProvidedCodeType_t;

typedef struct ATTUserProvidedCode_t {
    ATTProvidedCodeType_t type;
    char            data[25];
} ATTUserProvidedCode_t;

typedef enum ATTSpecificEvent_t {
    SE_ANSWER = 11,
    SE_DISCONNECT = 4
} ATTSpecificEvent_t;

typedef struct ATTUserCollectCode_t {
    ATTCollectCodeType_t type;
    short           digitsToBeCollected;
    short           timeout;
    ConnectionID_t  collectParty;
    ATTSpecificEvent_t specificEvent;
} ATTUserCollectCode_t;

typedef enum ATTDropResource_t {
    DR_NONE = -1,
    DR_CALL_CLASSIFIER = 0,
    DR_TONE_GENERATOR = 1
} ATTDropResource_t;

typedef struct ATTClearConnection_t {
    ATTDropResource_t dropResource;
    ATTUserToUserInfo_t userInfo;
} ATTClearConnection_t;

typedef struct ATTConsultationCall_t {
    DeviceID_t      destRoute;
    Boolean         priorityCalling;
    ATTUserToUserInfo_t userInfo;
} ATTConsultationCall_t;

typedef struct ATTMakeCall_t {
    DeviceID_t      destRoute;
    Boolean         priorityCalling;
    ATTUserToUserInfo_t userInfo;
} ATTMakeCall_t;

typedef struct ATTDirectAgentCall_t {
    DeviceID_t      split;
    Boolean         priorityCalling;
    ATTUserToUserInfo_t userInfo;
} ATTDirectAgentCall_t;

typedef struct ATTMakePredictiveCall_t {
    Boolean         priorityCalling;
    short           maxRings;
    ATTAnswerTreat_t answerTreat;
    DeviceID_t      destRoute;
    ATTUserToUserInfo_t userInfo;
} ATTMakePredictiveCall_t;

typedef struct ATTSupervisorAssistCall_t {
    DeviceID_t      split;
    ATTUserToUserInfo_t userInfo;
} ATTSupervisorAssistCall_t;

typedef struct ATTReconnectCall_t {
    ATTDropResource_t dropResource;
    ATTUserToUserInfo_t userInfo;
} ATTReconnectCall_t;

typedef struct ATTSendDTMFTone_t {
    ConnectionID_t  sender;
    ATTConnIDList_t receivers;
    char            tones[33];
    short           toneDuration;
    short           pauseDuration;
} ATTSendDTMFTone_t;

typedef struct ATTSendDTMFToneConfEvent_t {
    Nulltype        null;
} ATTSendDTMFToneConfEvent_t;

typedef struct ATTSetAgentState_t {
    ATTWorkMode_t   workMode;
} ATTSetAgentState_t;

typedef struct ATTQueryAcdSplit_t {
    DeviceID_t      device;
} ATTQueryAcdSplit_t;

typedef struct ATTQueryAcdSplitConfEvent_t {
    short           availableAgents;
    short           callsInQueue;
    short           agentsLoggedIn;
} ATTQueryAcdSplitConfEvent_t;

typedef struct ATTQueryAgentLogin_t {
    DeviceID_t      device;
} ATTQueryAgentLogin_t;

typedef long            ATTPrivEventCrossRefID_t;

typedef struct ATTQueryAgentLoginConfEvent_t {
    ATTPrivEventCrossRefID_t privEventCrossRefID;
} ATTQueryAgentLoginConfEvent_t;

typedef struct ATTQueryAgentLoginResp_t {
    ATTPrivEventCrossRefID_t privEventCrossRefID;
    struct {
        short           count;
        DeviceID_t      device[10];
    } list;
} ATTQueryAgentLoginResp_t;

typedef struct ATTQueryAgentState_t {
    DeviceID_t      split;
} ATTQueryAgentState_t;

typedef struct ATTQueryAgentStateConfEvent_t {
    ATTWorkMode_t   workMode;
    ATTTalkState_t  talkState;
} ATTQueryAgentStateConfEvent_t;

typedef struct ATTQueryCallClassifier_t {
    Nulltype        null;
} ATTQueryCallClassifier_t;

typedef struct ATTQueryCallClassifierConfEvent_t {
    short           numAvailPorts;
    short           numInUsePorts;
} ATTQueryCallClassifierConfEvent_t;

typedef struct ATTQueryDeviceInfoConfEvent_t {
    ATTExtensionClass_t extensionClass;
} ATTQueryDeviceInfoConfEvent_t;

typedef struct ATTQueryMwiConfEvent_t {
    ATTMwiApplication_t applicationType;
} ATTQueryMwiConfEvent_t;

typedef struct ATTQueryStationStatus_t {
    DeviceID_t      device;
} ATTQueryStationStatus_t;

typedef struct ATTQueryStationStatusConfEvent_t {
    Boolean         stationStatus;
} ATTQueryStationStatusConfEvent_t;

typedef struct ATTQueryTod_t {
    Nulltype        null;
} ATTQueryTod_t;

typedef struct ATTQueryTodConfEvent_t {
    short           year;
    short           month;
    short           day;
    short           hour;
    short           minute;
    short           second;
} ATTQueryTodConfEvent_t;

typedef struct ATTQueryTg_t {
    DeviceID_t      device;
} ATTQueryTg_t;

typedef struct ATTQueryTgConfEvent_t {
    short           idleTrunks;
    short           usedTrunks;
} ATTQueryTgConfEvent_t;

typedef struct ATTSnapshotDeviceConfEvent_t {
    short           count;
    ATTSnapshotDevice_t snapshotDevice[6];
} ATTSnapshotDeviceConfEvent_t;

typedef struct ATTMonitorFilter_t {
    ATTPrivateFilter_t privateFilter;
} ATTMonitorFilter_t;

typedef struct ATTMonitorConfEvent_t {
    ATTPrivateFilter_t usedFilter;
} ATTMonitorConfEvent_t;

typedef struct ATTMonitorStopOnCall_t {
    CSTAMonitorCrossRefID_t monitorCrossRefID;
    ConnectionID_t  call;
} ATTMonitorStopOnCall_t;

typedef struct ATTMonitorStopOnCallConfEvent_t {
    Nulltype        null;
} ATTMonitorStopOnCallConfEvent_t;

typedef struct ATTMonitorCallConfEvent_t {
    ATTPrivateFilter_t usedFilter;
    ATTSnapshotCall_t snapshotCall;
} ATTMonitorCallConfEvent_t;

typedef enum ATTReasonCode_t {
    AR_NONE = 0,
    AR_ANSWER_NORMAL = 1,
    AR_ANSWER_TIMED = 2,
    AR_ANSWER_VOICE_ENERGY = 3,
    AR_ANSWER_MACHINE_DETECTED = 4,
    AR_SIT_REORDER = 5,
    AR_SIT_NO_CIRCUIT = 6,
    AR_SIT_INTERCEPT = 7,
    AR_SIT_VACANT_CODE = 8,
    AR_SIT_INEFFECTIVE_OTHER = 9,
    AR_SIT_UNKNOWN = 10,
    AR_IN_QUEUE = 11
} ATTReasonCode_t;

typedef enum ATTReasonForCallInfo_t {
    OR_NONE = 0,
    OR_CONSULTATION = 1,
    OR_CONFERENCED = 2,
    OR_TRANSFERRED = 3,
    OR_NEW_CALL = 4
} ATTReasonForCallInfo_t;

typedef struct ATTOriginalCallInfo_t {
    ATTReasonForCallInfo_t reason;
    CallingDeviceID_t callingDevice;
    CalledDeviceID_t calledDevice;
    DeviceID_t      trunk;
    DeviceID_t      trunkMember;
    ATTLookaheadInfo_t lookaheadInfo;
    ATTUserEnteredCode_t userEnteredCode;
    ATTUserToUserInfo_t userInfo;
} ATTOriginalCallInfo_t;

typedef struct ATTCallClearedEvent_t {
    ATTReasonCode_t reason;
} ATTCallClearedEvent_t;

typedef struct ATTConferencedEvent_t {
    ATTOriginalCallInfo_t originalCallInfo;
} ATTConferencedEvent_t;

typedef struct ATTConnectionClearedEvent_t {
    ATTUserToUserInfo_t userInfo;
} ATTConnectionClearedEvent_t;

typedef enum ATTDeliveredType_t {
    DELIVERED_TO_ACD = 1,
    DELIVERED_TO_STATION = 2,
    DELIVERED_OTHER = 3
} ATTDeliveredType_t;

typedef struct ATTDeliveredEvent_t {
    ATTDeliveredType_t deliveredType;
    DeviceID_t      trunk;
    DeviceID_t      trunkMember;
    DeviceID_t      split;
    ATTLookaheadInfo_t lookaheadInfo;
    ATTUserEnteredCode_t userEnteredCode;
    ATTUserToUserInfo_t userInfo;
    ATTReasonCode_t reason;
    ATTOriginalCallInfo_t originalCallInfo;
} ATTDeliveredEvent_t;

typedef struct ATTEnteredDigitsEvent_t {
    ConnectionID_t  connection;
    char            digits[25];
    LocalConnectionState_t localConnectionInfo;
    CSTAEventCause_t cause;
} ATTEnteredDigitsEvent_t;

typedef struct ATTEstablishedEvent_t {
    DeviceID_t      trunk;
    DeviceID_t      trunkMember;
    DeviceID_t      split;
    ATTLookaheadInfo_t lookaheadInfo;
    ATTUserEnteredCode_t userEnteredCode;
    ATTUserToUserInfo_t userInfo;
    ATTReasonCode_t reason;
    ATTOriginalCallInfo_t originalCallInfo;
} ATTEstablishedEvent_t;

typedef struct ATTNetworkReachedEvent_t {
    ATTProgressLocation_t progressLocation;
    ATTProgressDescription_t progressDescription;
} ATTNetworkReachedEvent_t;

typedef struct ATTTransferredEvent_t {
    ATTOriginalCallInfo_t originalCallInfo;
} ATTTransferredEvent_t;

typedef struct ATTRouteRequestEvent_t {
    DeviceID_t      trunk;
    ATTLookaheadInfo_t lookaheadInfo;
    ATTUserEnteredCode_t userEnteredCode;
    ATTUserToUserInfo_t userInfo;
} ATTRouteRequestEvent_t;

typedef struct ATTRouteSelect_t {
    DeviceID_t      callingDevice;
    DeviceID_t      directAgentCallSplit;
    Boolean         priorityCalling;
    DeviceID_t      destRoute;
    ATTUserCollectCode_t collectCode;
    ATTUserProvidedCode_t userProvidedCode;
    ATTUserToUserInfo_t userInfo;
} ATTRouteSelect_t;

typedef struct ATTRouteUsedEvent_t {
    DeviceID_t      destRoute;
} ATTRouteUsedEvent_t;

typedef struct ATTSysStat_t {
    Boolean         linkStatusReq;
} ATTSysStat_t;

typedef enum ATTLinkState_t {
    LS_LINK_UNAVAIL = 0,
    LS_LINK_UP = 1,
    LS_LINK_DOWN = 2
} ATTLinkState_t;

typedef struct ATTLinkStatus_t {
    short           linkID;
    ATTLinkState_t  linkState;
} ATTLinkStatus_t;

typedef struct ATTLinkStatusEvent_t {
    short           count;
    ATTLinkStatus_t linkStatus[4];
} ATTLinkStatusEvent_t;


extern void FAR *att_asn_tbl;    /* encoder-decoder control table */

#endif
