/*****************************************************************************/
/* Copyright (C) 1995 Novell, Inc. and AT&T Bell Labs.  All rights reserved. */
/*****************************************************************************/
/* abstract syntax: sdb_asn_tbl */
/* last module in input: SDB-control-services */
/* created: Tue May  9 11:30:15 1995 */
/* associated control file: sdbdefs.c */

#ifndef SDBDEFS_H
#define SDBDEFS_H

#include "tsplatfm.h"


#define          SDB_OPEN_CONNECTION 1
#define          SDB_OPEN_CONN_CONF 2
#define          SDB_CLOSE_CONNECTION 3
#define          SDB_CLOSE_CONN_CONF 4
#define          SDB_INSERT_OBJECT 5
#define          SDB_INSERT_OBJECT_CONF 6
#define          SDB_INSERT_ATTRIBUTE 7
#define          SDB_INSERT_ATTRIBUTE_CONF 8
#define          SDB_DELETE_OBJECT 9
#define          SDB_DELETE_OBJECT_CONF 10
#define          SDB_DELETE_ATTRIBUTE 11
#define          SDB_DELETE_ATTRIBUTE_CONF 12
#define          SDB_SELECT_OBJECT 13
#define          SDB_SELECT_OBJECT_CONF 14
#define          SDB_OPEN_CURSOR 15
#define          SDB_OPEN_CURSOR_CONF 16
#define          SDB_FETCH_CURSOR 17
#define          SDB_FETCH_CURSOR_CONF 18
#define          SDB_CLOSE_CURSOR 19
#define          SDB_CLOSE_CURSOR_CONF 20
#define          SDB_MODIFY_OBJECT 21
#define          SDB_MODIFY_OBJECT_CONF 22
#define          SDB_START_TRANS 23
#define          SDB_START_TRANS_CONF 24
#define          SDB_COMMIT_TRANS 25
#define          SDB_COMMIT_TRANS_CONF 26
#define          SDB_ROLLBACK_TRANS 27
#define          SDB_ROLLBACK_TRANS_CONF 28
#define          SDB_BACKUP_DATA_BASE 29
#define          SDB_BACKUP_DATA_BASE_CONF 30
#define          SDB_UPDATE_DATA_BASE 31
#define          SDB_UPDATE_DATA_BASE_CONF 32
#define          SDB_CREATE_TEMPLATE 33
#define          SDB_CREATE_TEMPLATE_CONF 34
#define          SDB_QUERY_VERSIONS 35
#define          SDB_QUERY_VERSIONS_CONF 36
#define          SDB_QUERY_FILES 37
#define          SDB_QUERY_FILES_CONF 38
#define          SDB_QUERY_ATTRIBUTES 39
#define          SDB_QUERY_ATTRIBUTES_CONF 40
#define          SDB_QUERY_STATUS 41
#define          SDB_QUERY_STATUS_CONF 42
#define          SDB_UNIVERSAL_FAILURE_CONF 43
#define          SDB_UNIVERSAL_FAILURE 44
#define          SDB_SELECT_KEY 45
#define          SDB_SELECT_KEY_CONF 46

typedef char            SDBContext_t[512];

typedef char            SDBVersion_t[22];

typedef char            SDBBtrvVersion_t[8];

typedef unsigned long   SDBFileType_t;
#define                     SDB_ORG 0x40000000
#define                     SDB_ORGUNIT 0x20000000
#define                     SDB_SIMPLE 0x10000000
#define                     SDB_USER 0x00000001
#define                     SDB_WORKTOP 0x00000002
#define                     SDB_DEVICE 0x00000004
#define                     SDB_DLIST 0x00000008
#define                     SDB_TLINK 0x00000010
#define                     SDB_TLIST 0x00000020
#define                     SDB_OAMLIST 0x00000040
#define                     SDB_TSERV 0x00000080
#define                     SDB_DLIST_INDEX 0x00000100
#define                     SDB_TLIST_INDEX 0x00000200
#define                     SDB_OAMLIST_INDEX 0x00000400
#define                     SDB_INDEX 0x00000800

typedef enum SDBAttributeID_t {
    NULL_ATTR = 0,
    LOGIN = 100,
    USER_NAME = 101,
    USER_WKTP = 102,
    DEV_DEV_LIST = 103,
    CALL_DEV_LIST = 104,
    CALL_CALL = 105,
    CALL_CTL_LIST = 106,
    ROUTING_LIST = 107,
    OAM_LIST = 108,
    SUPER_ADMIN_USER = 109,
    ACL_USER = 110,
    WKTP_NAME = 200,
    WKTP_DEVICE = 201,
    IPX_LAN_ADDR = 202,
    IP_LAN_ADDR = 203,
    IP_NAME = 204,
    WKTP_DLIST = 205,
    ACL_WKTP = 206,
    WKTP_INDEX = 207,
    DEVICE_ID = 300,
    DB_DEVICE_TYPE = 301,
    DEVICE_TLIST = 302,
    LOCATION = 303,
    TELEPHONE_NO = 304,
    ACL_DEVICE = 305,
    DEVICE_INDEX = 306,
    DLIST_NAME = 400,
    EXCEPT_LIST = 401,
    DLIST_DEVICE = 402,
    ACL_DLIST = 403,
    DLIST_INDEX = 404,
    DLST_INDX = 490,
    DEV_INDX = 491,
    DLST_COMB = 492,
    TLINK_NAME = 500,
    TSDI_SIZE = 501,
    HW_MARK = 502,
    CONN_ECB = 503,
    RECV_ECB = 504,
    SEND_ECB = 505,
    TLINK_STATUS = 506,
    SECURITY_LEVEL = 507,
    TLINK_IPX_ADDR = 508,
    TLINK_IP_ADDR = 509,
    SERVICE_TYPE = 510,
    DRVR_TRAFFIC = 511,
    CSRV_TRAFFIC = 512,
    TDI_TRAFFIC = 513,
    DRVR_PEAK_THRSH = 514,
    CSRV_PEAK_THRSH = 515,
    TDI_DWN_PK_THRSH = 516,
    TDI_UP_PK_THRSH = 517,
    TDI_DWN_QLEN_THRSH = 518,
    TDI_UP_QLEN_THRSH = 519,
    TDI_DWN_QTM_THRSH = 520,
    TDI_UP_QTM_THRSH = 521,
    CSDI_SIZE = 522,
    CSDI_HW_MARK = 523,
    CSDI_LW_MARK = 524,
    ACL_TLINK = 525,
    TLINK_INDEX = 526,
    TLIST_NAME = 600,
    TLIST_LINKNM = 601,
    ACL_TLIST = 602,
    TLIST_INDEX = 603,
    TLST_INDX = 690,
    TLNK_INDX = 691,
    TLIST_COMB = 692,
    OAMLIST_NAME = 700,
    OAMLIST_LINKNM = 701,
    ACL_OAMLIST = 702,
    OAMLIST_INDEX = 703,
    OAMLST_INDX = 790,
    OAMLNK_INDX = 791,
    OAMLIST_COMB = 792,
    SERVER_NAME = 800,
    ADVERTISE_NS = 801,
    ELOG_TRACE = 802,
    ELOG_CAUTION = 803,
    ELOG_AUDIT = 804,
    ELOG_WARNING = 805,
    ELOG_ERROR = 806,
    ELOG_FATAL = 807,
    ELOG_SIZE = 808,
    ALARM_NOTIFY = 809,
    MSG_RATE_HW = 810,
    MSG_RATE_SIZE = 811,
    TRACE_DRIVERS = 812,
    TRACE_CLIENTS = 813,
    SDB_LOG = 814,
    SDB_LOG_SIZE = 815,
    TSERV_CUST_VER = 816,
    TSERV_INT_VER = 817,
    RESTRICT_USERS = 818,
    SERIAL_NUMBER = 819,
    AUTO_ADMIN = 820,
    LICENSE_SIZE = 821,
    TCP_LISTEN = 822,
    SPX_LISTEN = 823,
    SERV_MAX_TCP_CONN = 824,
    TRAFFIC_MEAS = 825,
    TRAFFIC_LOG_SZ = 826,
    PEAK_ARR_INT = 827,
    TSRV_TRAFFIC = 828,
    TSRV_PEAK_THRSH = 829,
    TCP_ADDRESS = 830,
    TCP_NAME_FORMAT = 831,
    SPLMNT_NDS_ADV = 832,
    SDB_SCHEMA_VER = 833,
    TRAF_LOG_OFFSET = 834,
    SDB_LOG_OFFSET = 835,
    ACL_TSERV = 836,
    ORG_NAME = 900,
    ACL_ORG = 901,
    ORGUNIT_NAME = 910,
    ACL_ORGUNIT = 911
} SDBAttributeID_t;

typedef char            SDBFileName_t[22];

typedef SDBFileName_t   SDBFlatFileName_t;

typedef SDBFileName_t   SDBSimpleFileName_t;

typedef SDBFileName_t   SDBErrorFileName_t;

typedef short           SDBConnectionID_t;

typedef short           SDBAttrDataLength_t;

typedef char            SDBComments_t[256];

typedef char            SDBAttributeName_t[22];

typedef char            SDBLoginName_t[49];

typedef short           SDBBufferSize_t;

typedef short           SDBConnectCount_t;

typedef short           SDBFileReadCount_t;

typedef _Int             SDBMemoryUsed_t;

typedef short           SDBReturnedCount_t;

typedef unsigned char   SDBDriverType_t;
#define                     SDB_BTRIEVE 0x40
#define                     SDB_NDS 0x20

typedef enum SDBRetrievalStatus_t {
    SDB_RET_SUCCESS = 0,
    SDB_RET_MORE_DATA = 1,
    SDB_RET_END_OF_FILE = 2
} SDBRetrievalStatus_t;

typedef enum SDBDriverState_t {
    SDB_NORMAL = 1,
    SDB_INITIALIZED = 2,
    SDB_INCONSISTENT = 3,
    SDB_UNINITIALIZED = 4,
    SDB_OLD_DATABASE = 5
} SDBDriverState_t;

typedef enum SDBAttrDataType_t {
    SDB_SHORT = 100,
    SDB_LONG = 200,
    SDB_STR = 300,
    SDB_BOOL = 400,
    SDB_STR_DN = 500,
    SDB_IPX = 600,
    SDB_IP = 700,
    SDB_ACL = 800,
    SDB_PHONE = 900
} SDBAttrDataType_t;

typedef short           SDBBulkAddIgnore_t;

typedef short           SDBMultiValOpt_t;

typedef short           SDBPrimaryKeyOpt_t;

typedef short           SDBQueryFlg_t;

typedef char            FAR *SDBAttrVariable_t;

typedef struct SDBAttrHdr_t {
    SDBAttributeID_t attrID;
    SDBAttrVariable_t attrDesc;
} SDBAttrHdr_t;

typedef struct SDBAttributeList_t {
    _Int             count;
    SDBAttrHdr_t    FAR *sdbAttrHdr;
} SDBAttributeList_t;

typedef SDBAttributeList_t SDBKeyList_t;

typedef struct SDBSelectAttrList_t {
    _Int             count;
    int             FAR *value;
} SDBSelectAttrList_t;

typedef struct SDBFileHdr_t {
    SDBFileType_t   fileType;
    SDBFileName_t   fileName;
} SDBFileHdr_t;

typedef struct SDBFileList_t {
    _Int             count;
    SDBFileHdr_t    FAR *sdbFileHdr;
} SDBFileList_t;

typedef struct SDBQryAttr_t {
    SDBAttributeID_t attrID;
    SDBAttributeName_t attrName;
    SDBAttributeID_t rootID;
    SDBAttrDataLength_t dataLen;
    SDBAttrDataType_t dataType;
    SDBPrimaryKeyOpt_t primaryKey;
    SDBMultiValOpt_t multiVal;
    SDBBulkAddIgnore_t baIgnore;
    SDBQueryFlg_t   flag1;
    SDBQueryFlg_t   flag2;
} SDBQryAttr_t;

typedef struct SDBQryAttrList_t {
    _Int             count;
    SDBQryAttr_t    FAR *sdbQryAttr;
} SDBQryAttrList_t;

typedef enum SDBSelectOpcodes_t {
    SDB_GET_ALL = 1,
    SDB_GET_EQUAL = 2,
    SDB_EXT_GET_EQUAL = 3,
    SDB_GET_GROUP = 4,
    SDB_EXT_GET_GROUP = 5
} SDBSelectOpcodes_t;

typedef enum SDBFailureCodes_t {
    SDB_CORRUPT_DICTNRY = 501,
    SDB_BAD_INDEX_FILE = 502,
    SDB_MISSING_DICTIONARY = 503,
    SDB_INVALID_STATE = 504,
    SDB_INVALID_ATTRIBUTE_TYPE = 505,
    SDB_TOO_MANY_ATTRIBUTES = 506,
    SDB_INVALID_FILE_TYPE = 507,
    SDB_ATTR_NOT_IN_FILE = 508,
    SDB_INVALID_COMMAND = 509,
    SDB_RECORD_NOT_FOUND = 510,
    SDB_DATABASE_ERROR = 511,
    SDB_INCONSISTENT_DATABASE = 512,
    SDB_INTERNAL_ERR = 513,
    SDB_CONNECTION_TABLE_FULL = 514,
    SDB_INVALID_CONNECTION_ID = 515,
    SDB_CONNECTION_NOT_ACTIVE = 516,
    SDB_INVALID_CONTEXT = 517,
    SDB_LOGIN_TABLE_FULL = 518,
    SDB_FAILED_LOGIN = 519,
    SDB_NO_PERMISSIONS = 520,
    SDB_INVALID_DATA = 521,
    SDB_MISSING_PRIMARY_KEY = 522,
    SDB_MANDATORY_ATTRIBUTE_MISSING = 523,
    SDB_INVALID_PRIMARY_KEY = 524,
    SDB_INVALID_KEY = 525,
    SDB_DUPLICATE_KEY = 526,
    SDB_MULTI_VAL_ATTR = 527,
    SDB_NOT_MULTI_VALUED = 528,
    SDB_INVALID_LIST_FILE = 529,
    SDB_CURSOR_NOT_ACTIVE = 530,
    SDB_CURSOR_SELECTION_NOT_SET = 531,
    SDB_INVALID_CURSOR_OP = 532,
    SDB_CURSOR_ALREADY_ACTIVE = 533,
    SDB_CURSOR_ACTIVE = 534,
    SDB_OBJECT_NOT_ACCESSED = 535,
    SDB_CONTENTION = 536,
    SDB_NO_MORE_DISK_SPACE = 537,
    SDB_NO_MEMORY = 538,
    SDB_MAX_OPEN_FILES_EXCEEDED = 539,
    SDB_NO_ACTIVE_TRANSACTION = 540,
    SDB_TRANSACTION_ALREADY_ACTIVE = 541,
    SDB_TRANSACTION_ERROR = 542,
    SDB_TRANSACTION_ABORTED = 543,
    SDB_INVALID_OPCODE = 544,
    SDB_INVALID_RTN_CNT = 545,
    SDB_BUF_TOO_SMALL = 546,
    SDB_KEY_SPECIFICATION = 547,
    SDB_ATTR_OVER_MAX = 548,
    SDB_ATTR_UNDER_MIN = 549,
    SDB_DATA_TOO_LARGE = 550,
    SDB_DOT_IN_KEY = 551,
    SDB_WRITE_FAILED = 552,
    SDB_READ_FAILURE = 553,
    SDB_FILE_NOT_PRESENT = 554,
    SDB_NO_INFORM1_LINE = 555,
    SDB_INVALID_ATTR_LIST = 556,
    SDB_INVALID_KEY_LIST = 557,
    SDB_INVALID_SELECT_LIST = 558,
    SDB_FOREIGN_KEY = 559,
    SDB_OLD_DICTIONARY_FAILURE = 560,
    SDB_UPGRADE_ERR = 561,
    SDB_FILE_ALREADY_EXISTS = 562,
    SDB_OPEN_SDB_LOG_FAILED = 563,
    SDB_WRITE_SDB_LOG_FAILED = 564,
    SDB_FILE_OPEN_FAILURE = 565,
    SDB_QUERY_VERS_FAILED = 566,
    SDB_BA_BACKUP_FAILED = 567,
    SDB_SIMPLE_UPDATE_FAILED = 568,
    SDB_QRY_FILES_FAILED = 569,
    SDB_QRY_ATTR_FAILED = 570,
    SDB_INVALID_INPUT_LINE = 571,
    SDB_CREATE_TMPLT_FAILED = 572,
    SDB_FLAT_UPDATE_FAILED = 573,
    SDB_CANT_MODIFY_MVATTR = 574,
    SDB_DUPLICATE_FILE_NAMES = 575,
    SDB_INVALID_VENDOR_LEN = 576,
    SDB_INVALID_SERVICE_LEN = 577,
    SDB_INVALID_SRV_TYPE = 578,
    SDB_INVALID_SRV_NAME_LEN = 579,
    SDB_LAST_ERR = 599
} SDBFailureCodes_t;

typedef unsigned char   SDBOptions_t;
#define                     SDB_NON_FATAL 0x40
#define                     SDB_OVERWRITE 0x20
#define                     SDB_CONVERT_SIMPLE 0x10
#define                     SDB_CONVERT_FLAT 0x08

typedef struct SDBOpenConnection_t {
    SDBContext_t    context;
    SDBLoginName_t  login;
} SDBOpenConnection_t;

typedef struct SDBOpenConnConfEvent_t {
    SDBConnectionID_t connID;
    SDBContext_t    context;
} SDBOpenConnConfEvent_t;

typedef struct SDBCloseConnection_t {
    SDBConnectionID_t connID;
} SDBCloseConnection_t;

typedef struct SDBCloseConnConfEvent_t {
    Nulltype        null;
} SDBCloseConnConfEvent_t;

typedef struct SDBInsertObject_t {
    SDBConnectionID_t connID;
    SDBFileType_t   fileType;
    struct SDBAttributeList_t FAR *attrList;
} SDBInsertObject_t;

typedef struct SDBInsertObjectConfEvent_t {
    Nulltype        null;
} SDBInsertObjectConfEvent_t;

typedef struct SDBInsertAttribute_t {
    SDBConnectionID_t connID;
    SDBFileType_t   fileType;
    struct SDBAttributeList_t FAR *keyList;
    struct SDBAttributeList_t FAR *attrList;
} SDBInsertAttribute_t;

typedef struct SDBInsertAttributeConfEvent_t {
    Nulltype        null;
} SDBInsertAttributeConfEvent_t;

typedef struct SDBDeleteObject_t {
    SDBConnectionID_t connID;
    SDBFileType_t   fileType;
    struct SDBAttributeList_t FAR *keyList;
} SDBDeleteObject_t;

typedef struct SDBDeleteObjectConfEvent_t {
    Nulltype        null;
} SDBDeleteObjectConfEvent_t;

typedef struct SDBDeleteAttribute_t {
    SDBConnectionID_t connID;
    SDBFileType_t   fileType;
    struct SDBAttributeList_t FAR *keyList;
    struct SDBAttributeList_t FAR *attrList;
} SDBDeleteAttribute_t;

typedef struct SDBDeleteAttributeConfEvent_t {
    Nulltype        null;
} SDBDeleteAttributeConfEvent_t;

typedef struct SDBSelectObject_t {
    SDBConnectionID_t connID;
    SDBFileType_t   fileType;
    struct SDBAttributeList_t FAR *keyList;
    SDBSelectOpcodes_t opcode;
    struct SDBSelectAttrList_t FAR *attrList;
    SDBBufferSize_t bufSize;
    SDBReturnedCount_t retrnCnt;
} SDBSelectObject_t;

typedef struct SDBSelectObjectConfEvent_t {
    struct SDBAttributeList_t FAR *attrList;
    SDBReturnedCount_t retrnCnt;
    SDBRetrievalStatus_t status;
} SDBSelectObjectConfEvent_t;

typedef struct SDBOpenCursor_t {
    SDBConnectionID_t connID;
} SDBOpenCursor_t;

typedef struct SDBOpenCursorConfEvent_t {
    Nulltype        null;
} SDBOpenCursorConfEvent_t;

typedef struct SDBFetchCursor_t {
    SDBConnectionID_t connID;
    SDBBufferSize_t bufSize;
    SDBReturnedCount_t retrnCnt;
} SDBFetchCursor_t;

typedef struct SDBFetchCursorConfEvent_t {
    struct SDBAttributeList_t FAR *attrList;
    SDBReturnedCount_t retrnCnt;
    SDBRetrievalStatus_t status;
} SDBFetchCursorConfEvent_t;

typedef struct SDBCloseCursor_t {
    SDBConnectionID_t connID;
} SDBCloseCursor_t;

typedef struct SDBCloseCursorConfEvent_t {
    Nulltype        null;
} SDBCloseCursorConfEvent_t;

typedef struct SDBModifyObject_t {
    SDBConnectionID_t connID;
    SDBFileType_t   fileType;
    struct SDBAttributeList_t FAR *keyList;
    struct SDBAttributeList_t FAR *attrList;
} SDBModifyObject_t;

typedef struct SDBModifyObjectConfEvent_t {
    Nulltype        null;
} SDBModifyObjectConfEvent_t;

typedef struct SDBStartTrans_t {
    SDBConnectionID_t connID;
} SDBStartTrans_t;

typedef struct SDBStartTransConfEvent_t {
    Nulltype        null;
} SDBStartTransConfEvent_t;

typedef struct SDBCommitTrans_t {
    SDBConnectionID_t connID;
} SDBCommitTrans_t;

typedef struct SDBCommitTransConfEvent_t {
    Nulltype        null;
} SDBCommitTransConfEvent_t;

typedef struct SDBRollbackTrans_t {
    SDBConnectionID_t connID;
} SDBRollbackTrans_t;

typedef struct SDBRollbackTransConfEvent_t {
    Nulltype        null;
} SDBRollbackTransConfEvent_t;

typedef struct SDBBackupDataBase_t {
    SDBFileName_t   fileNm;
    SDBComments_t   comments;
} SDBBackupDataBase_t;

typedef struct SDBBackupDataBaseConfEvent_t {
    Nulltype        null;
} SDBBackupDataBaseConfEvent_t;

typedef struct SDBUpdateDataBase_t {
    SDBFlatFileName_t flatFile;
    SDBSimpleFileName_t simpleFile;
    SDBErrorFileName_t errorFile;
    SDBOptions_t    options;
} SDBUpdateDataBase_t;

typedef struct SDBUpdateDataBaseConfEvent_t {
    Nulltype        null;
} SDBUpdateDataBaseConfEvent_t;

typedef struct SDBCreateTemplate_t {
    SDBFlatFileName_t flatFile;
    SDBSimpleFileName_t simpleFile;
} SDBCreateTemplate_t;

typedef struct SDBCreateTemplateConfEvent_t {
    Nulltype        null;
} SDBCreateTemplateConfEvent_t;

typedef struct SDBQueryVersions_t {
    Nulltype        null;
} SDBQueryVersions_t;

typedef struct SDBQueryVersionsConfEvent_t {
    SDBVersion_t    dataDictionaryVersion;
    SDBVersion_t    oldDictionaryVersion;
    SDBVersion_t    overallVersion;
    SDBVersion_t    userVersion;
    SDBVersion_t    worktopVersion;
    SDBVersion_t    deviceVersion;
    SDBVersion_t    dlistVersion;
    SDBVersion_t    tlinkVersion;
    SDBVersion_t    tlistVersion;
    SDBVersion_t    oamlistVersion;
    SDBVersion_t    tservVersion;
    SDBDriverType_t driverType;
    SDBVersion_t    driverVersion;
    SDBVersion_t    tsrvnlmVersion;
    SDBDriverState_t driverState;
    SDBBtrvVersion_t btrvVersion;
} SDBQueryVersionsConfEvent_t;

typedef struct SDBQueryFiles_t {
    SDBBufferSize_t bufSize;
} SDBQueryFiles_t;

typedef struct SDBQueryFilesConfEvent_t {
    struct SDBFileList_t FAR *fileList;
} SDBQueryFilesConfEvent_t;

typedef struct SDBQueryAttributes_t {
    SDBFileType_t   fileType;
    SDBBufferSize_t bufSize;
    SDBReturnedCount_t retrnCnt;
} SDBQueryAttributes_t;

typedef struct SDBQueryAttributesConfEvent_t {
    struct SDBQryAttrList_t FAR *attrList;
    SDBReturnedCount_t retrnCnt;
    SDBRetrievalStatus_t status;
} SDBQueryAttributesConfEvent_t;

typedef struct SDBFileReadList_t {
    _Int             count;
    SDBFileReadCount_t FAR *sdbFileRd;
} SDBFileReadList_t;

typedef struct SDBQueryStatus_t {
    Nulltype        null;
} SDBQueryStatus_t;

typedef struct SDBQueryStatusConfEvent_t {
    SDBConnectCount_t sdbConns;
    SDBMemoryUsed_t memUsed;
    SDBFileReadList_t fileRd;
} SDBQueryStatusConfEvent_t;

typedef struct SDBUniversalFailureConfEvent_t {
    SDBFailureCodes_t error;
    SDBAttributeID_t attrID;
} SDBUniversalFailureConfEvent_t;

typedef struct SDBUniversalFailureEvent_t {
    SDBFailureCodes_t error;
} SDBUniversalFailureEvent_t;

typedef struct SDBSelectKey_t {
    SDBConnectionID_t connID;
    SDBFileType_t   fileType;
    SDBAttributeID_t key;
    SDBAttrHdr_t    filter;
    SDBBufferSize_t bufSize;
} SDBSelectKey_t;

typedef struct SDBSelectKeyConfEvent_t {
    SDBRetrievalStatus_t status;
    struct {
        short           length;
        unsigned char   FAR *value;
    } keyList;
} SDBSelectKeyConfEvent_t;


extern void FAR *sdb_asn_tbl;    /* encoder-decoder control table */

#endif
