/* GETS specific data structure declarations, description and
** associated macros.
**
** Copyright (c) by Victor Berry 1996 All rights reserved.
**
** Modification History:
**   23Jan97 VABerry : Added to Netphone code base
*/

/* This header file can be included more than once. This prevents errors in
** that case.
*/
#ifndef __GETS__H
#define __GETS__H

#define USE_GETS 1

#define STRSIZE 128
#define COMMANDS 25

#define clear_screen 0
#define clr_eol 1
#define clr_eos 2

/* Key codes */

#define UP_ARROW	129
#define DOWN_ARROW	130
#define LEFT_ARROW	131
#define RIGHT_ARROW	132
#define F1		133
#define F2		134
#define F3		135
#define HOME		136
#define END		137

#define EDIT_SELF_INSERT	0x01
#define EDIT_BEGIN_LINE		0x02
#define EDIT_END_LINE		0x03
#define EDIT_FORWARD_CHAR	0x04
#define EDIT_BACKWARD_CHAR	0x05
#define EDIT_PREVIOUS_LINE	0x06
#define EDIT_NEXT_LINE		0x07
#define EDIT_TWIDDLE		0x08
#define EDIT_DELETE_CHAR	0x09
#define EDIT_DELETE_PREV_CHAR	0x0A

#endif /*  __GETS__H */
